#!/usr/bin/env python

# /home/graham/bee_scales/combined_count_print_save-to-ramdisk-9-11_1.py
import time
import RPi.GPIO as GPIO
import datetime

# Variables
delay = 0.01
#delay_for_reverse = 15    #  15 seconds between motor bursts - OK
delay_for_reverse = 30    #  30 seconds between motor bursts
# 50 (0-49)steps equals on full revolution


# tell the GPIO module that we want to use the 
# chip's pin numbering scheme
GPIO.setmode(GPIO.BCM)
GPIO.setwarnings(False)
	
# Enable pins for IN1-4 to control step sequence
coil_A_1_pin = 23
coil_A_2_pin = 24
coil_B_1_pin = 4
coil_B_2_pin = 17
	
# Set pin states
GPIO.setup(coil_A_1_pin, GPIO.OUT)
GPIO.setup(coil_A_2_pin, GPIO.OUT)
GPIO.setup(coil_B_1_pin, GPIO.OUT)
GPIO.setup(coil_B_2_pin, GPIO.OUT)

# Function for step sequence
def setStep(w1, w2, w3, w4):
	GPIO.output(coil_A_1_pin, w1)
	GPIO.output(coil_A_2_pin, w2)
	GPIO.output(coil_B_1_pin, w3)
	GPIO.output(coil_B_2_pin, w4)
	


def main():
    steps = 100  # 50 for 1 full turn of the screw thread
    pulses = 0
    bursts = 0
    mm = 0   # movement in mm
    lb = 0
    float(mm)
    toggle = 0
    time_for_graph = "time"

    GPIO.setup(27,GPIO.IN)   # bottom switch.

     
    # setup pins 9 and 11 as an outputs for LEDs
    GPIO.setup(9,GPIO.OUT)   # LED 9
    GPIO.setup(11,GPIO.OUT)   # LED 11

    GPIO.output(11,False)
    GPIO.output(9,False)

    print "waiting for a contact change"
    while True:
        if not GPIO.input(27):			# bottom switch. is on    (low on pin)
             print "bar is touching the bottom contact"
             print "GPIO.input(27) =",GPIO.input(27)  

             GPIO.output(9,False)	    # and turn LED 2 on (resistor to +3V)

             time.sleep(delay_for_reverse)
             for i in range(0, steps):	   # move weight in
				setStep(1,0,1,0)        
				time.sleep(delay)
				setStep(0,1,1,0)
				time.sleep(delay)
				setStep(0,1,0,1)
				time.sleep(delay)
				setStep(1,0,0,1)
				time.sleep(delay)
             bursts = bursts - 1
             pulses = pulses - steps    
             
             # the screw is M8 (8mm diameter) 8 turns of the thread per cm so each turn is 0.125 mm
             # 50 pulses (1 burst of pulses) turns the screw 1 turn
             # 8turns = 400 pulses = 10mm  -  40 pulses = 1mm
             # 10lb = 267 mm along the weight track (measured with 20lb test weight)
             # 1lb = 26.7 mm  - so 1lb = 400 x 26.7 / 10 mm = 1068 pulses = 21.36 bursts
             
             # (for full time use time_for_graph = datetime.datetime.strftime(datetime.datetime.now(), '%Y-%m-%d %H:%M:%S')  )
             time_for_graph = datetime.datetime.strftime(datetime.datetime.now(), '%H:%M')
             date_time_for_graph = datetime.datetime.strftime(datetime.datetime.now(), '%y:%m:%d:%H:%M')
             date_for_filesaves = datetime.datetime.strftime(datetime.datetime.now(), '%y%m%d')  # (do not include :)
             
             mm = float(pulses)/40     # calculate mm movement
             lb = float(mm)/float(26.7)

             print "time now =",time_for_graph, "pulses = ",pulses,"    bursts = ",bursts, "    mm = ",'%.1f' % mm, "    lb = ",'%.2f' % lb
                     
             # bursts is a count showing where we are along the screw thread
             # the best time to take a record is one turn of the screw after the bar
             # has just drifted up to turn off the bottom switch.
             # so record the time and value 1 burst after coming here from the opposite movement cycle
             # if we are in a static  balance we record only on the bounce upwards
             # if the bees are coming home en-mass in the rain we will only take another reading
             # when balance is restored (or is it the opposite ???)
             
             if toggle:  				# toggle was set true (1) when moving in the other direction     
               f = open("/var/www/html/ramdisk2/mm_dated.txt","a") #opens file for append
               f.write(str(date_time_for_graph))                          
               f.write(";")
               f.write(str(mm))  # so we will plot mm of movement with full date   
               f.write("\n")
               f.close()
 
               lb2 = round(lb,2)
 
               f = open("/var/www/html/ramdisk2/lb_time.txt","a") #opens file for append
               f.write(str(time_for_graph))                          
               f.write(";")
               f.write(str(lb2))  # plot lb weight added
               f.write("\n")
               f.close()
               
               f = open("/var/www/html/ramdisk2/lb_dated.txt","a") #opens file for append
               f.write(str(date_time_for_graph))                          
               f.write(";")
               f.write(str(lb2))  # plot lb weight added
               f.write("\n")
               f.close()
                            
               print"       \/ \/ \/ \/ \/ \/ \/ \/ \/       hive getting lighter  :-("
               toggle = 0 # if we need to pulse a burst again with the contact closed do not record until after a contact opening event

        if GPIO.input(27):			# bottom switch. is off    (high on pin)
             print "BOTTOM CYCLE - bar is below the top contact"
             print "GPIO.input(27) =",GPIO.input(27)  

             GPIO.output(9,True)	    # and turn LED 2 on (resistor to +3V)

             time.sleep(delay_for_reverse)
             for i in range(0, steps):   # move weight out
				setStep(1,0,0,1)
				time.sleep(delay)
				setStep(0,1,0,1)
				time.sleep(delay)
				setStep(0,1,1,0)
				time.sleep(delay)
				setStep(1,0,1,0)
				time.sleep(delay)
             bursts = bursts + 1
             pulses = pulses + steps

             print "time now =",time_for_graph, "pulses = ",pulses,"    bursts = ",bursts, "    mm = ",'%.1f' % mm, "    lb = ",'%.2f' % lb

             if not toggle:  				# toggle was set false (0) when moving in the other direction
               print"       /\ /\ /\ /\ /\ /\ /\ /\ /\       hive getting heavier  :-)"
               toggle = 1
               
        time.sleep(.01)

    GPIO.cleanup()


if __name__=="__main__":
    main()
    