#!/usr/bin/env python

# /home/graham/i2c/ADS1115git/Adafruit_Python_ADS1x15/examples/simpletest_save4inputs_to_ramdisk4b.py
# Simple demo of reading each analog input from the ADS1x15 and printing it to
# the screen.
# Author: Tony DiCola
# License: Public Domain
# 10 turn pot  -  0lb = 2666    25lb = 17788
import time
import datetime
# Import the ADS1x15 module.
import Adafruit_ADS1x15
import os

# Create an ADS1115 ADC (16-bit) instance.
adc = Adafruit_ADS1x15.ADS1115()

# Or create an ADS1015 ADC (12-bit) instance.
#adc = Adafruit_ADS1x15.ADS1015()

# Note you can change the I2C address from its default (0x4b), and/or the I2C
# bus by passing in these optional parameters:
adc = Adafruit_ADS1x15.ADS1115(address=0x4b, busnum=1)

# Choose a gain of 1 for reading voltages from 0 to 4.09V.
# Or pick a different gain to change the range of voltages that are read:
#  - 2/3 = +/-6.144V
#  -   1 = +/-4.096V
#  -   2 = +/-2.04bV
#  -   4 = +/-1.024V
#  -   8 = +/-0.512V
#  -  16 = +/-0.256V
# See table 3 in the ADS1015/ADS1115 datasheet for more info on gain.
GAIN = 1

print('Reading ADS1x15 values, press Ctrl-C to quit...')
# Print nice channel column headers.
print('| {0:>6} | {1:>6} | {2:>6} | {3:>6} |'.format(*range(4)))
print('-' * 37)
# Main loop.
while True:
    # Read all the ADC channel values in a list.
    values = [0]*4
    for i in range(4):
        # Read the specified ADC channel using the previously set gain value.
        values[i] = adc.read_adc(i, gain=GAIN)
        
        # Note you can also pass in an optional data_rate parameter that controls
        # the ADC conversion time (in samples/second). Each chip has a different
        # set of allowed data rate values, see datasheet Table 9 config register
        # DR bit values.
        #values[i] = adc.read_adc(i, gain=GAIN, data_rate=128)
        # Each value will be a 12 or 16 bit signed integer value depending on the
        # ADC (ADS1015 = 12-bit, ADS1115 = 16-bit).
        
        

    print ""  
    # Print the ADC values.
    print('| {0:>6} | {1:>6} | {2:>6} | {3:>6} |'.format(*values))
    
    pool = 409.6 * values[3] / 32768 - 273.15   # degrees K = volts * 100
    pool = round(pool,2)
    panel = 409.6 * values[2] / 32768 - 273.15
    panel = round(panel,2)    
    air = ((4096 * values[1] / 32768) - 500) / float(10)
    air = round(air,2)
    potpounds = (values[0] - 2666) * 25 / float(15122)
    potpounds = round(potpounds,2)
    print "temperatures-> pool =",pool," panel =",panel, " air =",air, "\n pot pounds =",potpounds
    
    time_for_graph = datetime.datetime.strftime(datetime.datetime.now(), '%H:%M')
    print "time to save ",str(time_for_graph)
    
    i2c72temp = os.popen("i2c_lm75 72").read()
    print "i2c thermometer at i2c address 72 = ", i2c72temp
    
    f = open("/var/www/ramdisk/i2c72temp.txt","a")
    f.write(str(time_for_graph))                          
    f.write(";")
    f.write(str(i2c72temp))
    f.write("\n")
    f.close()
                      
    f = open("/var/www/ramdisk/4b3_pool.txt","a")
    f.write(str(time_for_graph))                          
    f.write(";")
    f.write(str(pool))
    f.write("\n")
    f.close()
    
    f = open("/var/www/ramdisk/4b2_panel.txt","a")
    f.write(str(time_for_graph))                          
    f.write(";")  
    f.write(str(panel))
    f.write("\n")
    f.close()
    
    f = open("/var/www/ramdisk/4b1_tmp36_pool-air.txt","a")
    f.write(str(time_for_graph))                          
    f.write(";")
    f.write(str(air))
    f.write("\n")
    f.close()
    
    f = open("/var/www/ramdisk/4b0_potpounds.txt","a")
    f.write(str(time_for_graph))                          
    f.write(";")
    f.write(str(potpounds))
    f.write("\n")
    f.close()
    
    # table of time panel pool air temperature values
    f = open("/var/www/ramdisk/4b0_AllData.txt","a")
    f.write(str(time_for_graph))
    f.write(";")  
    f.write(str(panel))
    f.write(";")
    f.write(str(pool))
    f.write(";")
    f.write(str(air))
    f.write(";")
    f.write(str(i2c72temp))
    f.write(";")
    f.write(str(potpounds))
    f.write("\n")
    f.close()
    
    
    
    # Pause seconds
    time.sleep(30)
    
    
    
